function Imp=midpointc(a,b,M,fun,varargin)
%MIDPOINTC intgration numrique composite du point
% milieu.
% IMP=MIDPOINTC(A,B,M,FUN) calcule une approximation
% de l'intgrale de la fonction FUN par la mthode du
% point milieu (avec M intervalles quirpartis).
% FUN prend en entre un vecteur rel x et renvoie
% un vecteur rel.
% FUN peut aussi tre un objet inline, une fonction
% anonyme ou dfinie par un m-file.
% IMP=MIDPOINT(A,B,M,FUN,P1,P2,...)  appelle la
% fonction FUN en passant les paramtres optionnels
% P1,P2,... de la maniere suivante: FUN(X,P1,P2,...).
H=(b-a)/M;
x = linspace(a+H/2,b-H/2,M);
fmp=feval(fun,x,varargin{:}).*ones(1,M);
Imp=H*sum(fmp);
return
