function D=qrbasic(A,tol,nmax)
%QRBASIC calcule les valeurs propres de la matrice A.
%  D=QRBASIC(A,TOL,NMAX) calcule par itrations QR
%  toutes les valeurs propres de A avec une tolrance
%  TOL en NMAX itrations au maximum. La convergence
%  de cette mthode n'est pas toujours garantie.
[n,m]=size(A);
if n ~= m, error('Matrices carres seulement'); end
T = A; niter = 0; test = norm(tril(A,-1),inf);
while niter <= nmax & test >= tol
    [Q,R]=qr(T);    T = R*Q;
    niter = niter + 1;
    test = norm(tril(T,-1),inf);
end
if niter > nmax
  warning(['La mthode ne converge pas dans le '
           'nombre d''itrations maximum voulu\n']);
else
  fprintf(['La methode converge en ' ...
           '%i itrations\n'],niter);
end
D = diag(T);
return
