function [Isic]=simpsonc(a,b,M,fun,varargin)
%SIMPSONC intgration numrique composite de Simpson.
% ISIC = SIMPSONC(A,B,M,FUN) calcule une approximation
% de l'intgrale de la fonction FUN par la mthode de
% Simpson (avec M intervalles quirpartis).
% FUN prend en entre un vecteur rel x et renvoie un
% vecteur de rels.
% FUN peut aussi tre un objet inline, une fonction
% anonyme ou dfinie par un m-file.
% ISIC=SIMPSONC(A,B,M,FUN,P1,P2,...)  appelle la
% fonction FUN en passant les paramtres optionnels
% P1,P2,... de la maniere suivante: FUN(X,P1,P2,...).
H=(b-a)/M;
x=linspace(a,b,M+1);
fpm=feval(fun,x,varargin{:}).*ones(1,M+1);
fpm(2:end-1) = 2*fpm(2:end-1);
Isic=H*sum(fpm)/6;
x=linspace(a+H/2,b-H/2,M);
fpm=feval(fun,x,varargin{:}).*ones(1,M);
Isic = Isic+2*H*sum(fpm)/3;
return
